<?php
// $Header: /home/name/projects/tv/RCS/stream-index.php,v 1.3 2012/12/16 04:52:13 name Exp $
//
// stream-index.php
//
//	Portal for PC based real-time TV streaming.
//	Copyright (c) 2012 Hiro Sugawara
//
?>
<HTML>
<META HTTP-EQUIV='Content-Type' CONTENT='text/html;charset=UTF-8'>
<HEAD>
<TITLE>
地上ディジタル放送ライブ・ストリーミング
</TITLE>
</HEAD>
<?php
$tzmins	= 9 * 60;	// JST default

$script_name = $_SERVER['SCRIPT_FILENAME'];
$output = array();
exec("sed 's|#.*$||' " .(dirname($script_name) . "/tv-dl.conf"), $output);
foreach ($output as $line) {
	eval($line);
}

//
// Get channel list dynamically from the recording server.
//
$channelOptions = '';
$channels = array();
$channelURL = preg_replace('/\\\\@/', '@', $CHANNELURL);

// Embedded URL open cannot handle username/password
if (($fp = popen("elinks -no-home -source \"$channelURL\"", 'r'))) {
	$matches = array();
	while (($line = trim(fgets($fp)))) {
		if (preg_match('/^(\d+):\s*(.*)$/', $line, $matches)) {
			$channelOptions .= sprintf("<OPTION VALUE=\"%s\">%s</OPTION>\n",
									$matches[1], $matches[2]);
		} else if (preg_match('/^tz:\s*(.*)$/i', $line, $matches)) {
			$tzmins = substr($matches[1], 0, -2) * 60 + substr($matches[1], -2);
		}
	}
	pclose($fp);
}
?>

<SCRIPT LANGUAGE='JavaScript'>
<!--
//
// real-time clock code from http://tycho.usno.navy.mil/rc.html
//
<?php
echo "var tzmins	= $tzmins;\n";
?>
var DOW		= new Array('日曜日', '月曜日', '火曜日', '水曜日',
						'木曜日', '金曜日', '土曜日');

var station = 'unknown';

var tick;
function stop() {
 	clearTimeout(tick);
}

function simpleClock() {
	var ct = new Date();
	var ut = ct.getTime() + ct.getTimezoneOffset() * 60 * 1000;
	var jst = new Date(ut + tzmins * 60 * 1000);
	var y, M, d, D, h, m, s;
	var date, time;
	y	= jst.getYear();
	M	= jst.getMonth() + 1;
	d	= jst.getDate();
	D	= jst.getDay();
	h	= jst.getHours();
	m	= jst.getMinutes();
	s	= jst.getSeconds();
	if (y < 2000) y += 1900;
	if (M <= 9) M = '0' + M;
	if (d <= 9) d = '0' + d;
	if (s <= 9) s = '0' + s;
	if (m <= 9) m = '0' + m;
	if (h <= 9) h = '0' + h;
	date = y + '/' + M + '/' + d;
	time = h + ':' + m + ':' + s;

	document.getElementById('time').innerHTML	= time;
	document.getElementById('date').innerHTML	= date;
	document.getElementById('dow').innerHTML	= DOW[D];
	tick	= setTimeout('simpleClock()', 1000);   
}

function updateStation() {
	document.getElementById('tuned').innerHTML = '<B>' +
		document.getElementById('channel').options[document.getElementById('channel').selectedIndex].text + '</B> ' +
		'<FONT SIZE="-2">' +
		document.getElementById('size').options[document.getElementById('size').selectedIndex].text + ' ' +
		document.getElementById('bitrate').options[document.getElementById('bitrate').selectedIndex].text +
		'</FONT>';
}
//-->
</SCRIPT>

<BODY onLoad='simpleClock();' onUnload='stop();'>
<TABLE WIDTH="100%">
  <TR><TD><FORM NAME="tune" METHOD="GET" TARGET="SFRAME" ACTION="stream.php">
  <TABLE WIDTH="100%" CELLSPACING=0>
    <TR BGCOLOR="#0000c0" VALIGN="bottom">
      <TD><FONT SIZE="+3" COLOR="white">
地上ディジタル放送ライブ・ストリーミング
      </FONT></TD>
      <TD><FONT COLOR="white">
	  <SPAN ID='date'>date</SPAN>
	  <SPAN ID='dow'>dow</SPAN>
	  <SPAN ID='time'>time</SPAN> JST
      </FONT></TD>
      <TD><FONT COLOR="white">
	    Station: </FONT>
	    <SELECT NAME="channel" ID="channel">
<?php
	echo "$channelOptions";
?>
	    </SELECT>
	  </TD>
      <TD><FONT COLOR="white">
	    Size: </FONT>
	    <SELECT NAME="size" ID="size">
		  <OPTION VALUE="1920x1080">1920x1080</OPTION>
		  <OPTION VALUE="1280x720">1280x720</OPTION>
		  <OPTION VALUE="853x480">853x480</OPTION>
		  <OPTION VALUE="720x405">720x405</OPTION>
		  <OPTION VALUE="640x360">640x360</OPTION>
		  <OPTION VALUE="480x270">480x270</OPTION>
		  <OPTION VALUE="320x180">320x180</OPTION>
	    </SELECT>
	  </TD>
      <TD><FONT COLOR="white">
	    Bit rate: </FONT>
	    <SELECT NAME="bitrate" ID="bitrate">
		  <OPTION VALUE="18000000">18Mbps</OPTION>
		  <OPTION VALUE="8000000">8Mbps</OPTION>
		  <OPTION VALUE="6000000">6Mbps</OPTION>
		  <OPTION VALUE="4000000">4Mbps</OPTION>
		  <OPTION VALUE="2000000">2Mbps</OPTION>
		  <OPTION VALUE="1000000">1Mbps</OPTION>
		  <OPTION VALUE="500000">500kbps</OPTION>
	    </SELECT>
	  </TD>
	  <TD>
	    <INPUT TYPE="SUBMIT" VALUE="Tune" onClick="updateStation();">
	  </TD>
    </TR>
  </TABLE>
  </FORM ></TD></TR>
  <TR><TD>
    <TABLE><TR><TD>
    <IFRAME NAME="SFRAME" HEIGHT=160></IFRAME>
    </TD></TR>
    <TR><TD ALIGN="center"><B>
	視聴中:
	</B>
	<SPAN ID="tuned"></SPAN>
    </TD></TR>
	</TABLE>
  </TD></TR>
</TABLE>
</BODY>
</HTML>
